﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

namespace Saltosion.OneWeapon {
    public class PlayerFun : MonoBehaviour {

        public Player Player;

        public float MaxFun = 100;
        public float FunDegradeSpeed = 5;
        public float StandingStillMultiplier = 1.5f;

        public float WeaponFun = 20;
        public float EnemyExplosionFun = 6f;
        public float FurnitureExplosionFun = 3f;
        public float ShootingFunAmount = 0.5f;

        public float CurrentFun { private set; get; }

        public bool DebugAdd10Fun = false;

        public float CurrentDamageBoost { private set; get; }

        void Start() {
            CurrentFun = MaxFun * 0.75f;
        }

        void Update() {
            float Delta = FunDegradeSpeed * Time.deltaTime;
            if (!Player.IsMoving) {
                Delta *= StandingStillMultiplier;
            }
            float NewFun = CurrentFun - Delta;

            if (DebugAdd10Fun) {
                NewFun += 10;
                DebugAdd10Fun = false;
            }

            CurrentFun = Mathf.Clamp(NewFun, 0, MaxFun);

            CurrentDamageBoost = Mathf.Floor((CurrentFun / 100) * 12) / 12;

            if (CurrentFun <= 0) {
                SceneManager.LoadScene(3);
            }
        }

        private void AddFun(float fun) {
            float NewFun = CurrentFun + fun;
            CurrentFun = Mathf.Min(MaxFun, NewFun);
        }

        public void TakeDamage() {
            AddFun(-5f);
        }

        public void ReceiveNewWeapon() {
            AddFun(WeaponFun);
        }

        public void ShootingFun() {
            AddFun(ShootingFunAmount);
        }

        public void Explosion(bool isFurniture) {
            float NewFun = CurrentFun;
            if (isFurniture) {
                AddFun(FurnitureExplosionFun);
            } else {
                AddFun(EnemyExplosionFun);
            }
        }
    }
}
